#include "Boundary.h"
#include "FixVec.h"
#include "Parameters.h"

namespace AMDiS {

  BoundaryType newBound(BoundaryType oldBound, BoundaryType newBound)
  {
    if (newBound <= INTERIOR) {
      /*************************************************************************/
      /*  face on NEUMANN-boundary or interior face; weak type                 */
      /*************************************************************************/
      return(oldBound);
    } else {
      /*************************************************************************/
      /*  node is already node on the DIRICHLET boundary                       */
      /*************************************************************************/
      if (oldBound > newBound)
	return(oldBound);
      else
	return(newBound);
    }

    /**************************************************************************/
    /* new face is interior face; node type is always stronger                */
    /**************************************************************************/
    return(newBound);
  }

}
