#include "Estimator.h"
#include "Traverse.h"
#include "Parameters.h"

namespace AMDiS {

  Estimator::Estimator(std::string name_, int r) 
    : name(name_),
      norm(NO_NORM),
      row(r)
  {
    GET_PARAMETER(0, name + "->error norm", "%d", &norm);
  }

  double Estimator::estimate(double ts)
  {
    FUNCNAME("Estimator::estimate()");
  
    init(ts);

    TraverseStack stack;
    ElInfo *elInfo = stack.traverseFirst(mesh, -1, traverseFlag);
    while (elInfo) {
      estimateElement(elInfo);
      elInfo = stack.traverseNext(elInfo);
    }  

    exit();

    return est_sum;
  }
}
