#include "VertexVector.h"
#include "DOFAdmin.h"
#include "DOFIterator.h"

namespace AMDiS {

  VertexVector::VertexVector(const DOFAdmin *admin_, std::string name_)
    : DOFVectorDOF()
  {
    name = name_;
    feSpace = NULL;
    admin = admin_;
    const_cast<DOFAdmin*>(admin)->addDOFIndexed(this);
    const_cast<DOFAdmin*>(admin)->addDOFContainer(this);
  }

  VertexVector::~VertexVector()
  {
    const_cast<DOFAdmin*>(admin)->removeDOFIndexed(this);
    const_cast<DOFAdmin*>(admin)->removeDOFContainer(this);
  }

  void VertexVector::set(DegreeOfFreedom val)
  {
    DOFIteratorBase it(const_cast<DOFAdmin*>(admin), USED_DOFS);
    for(it.reset(); !it.end(); ++it) {
      if(!it.isDOFFree()) operator[](it.getDOFIndex()) = val;
    }
  } 

}
